

import edu.uoregon.tau.dms.dss.*;
import java.util.*;
import java.io.*;




class FileFilter implements FilenameFilter {
    public FileFilter(String regex) {
	this.regex = regex;
    }
    public boolean accept(File okplace, String patternmatch ) {
	//System.out.println("regex = " + regex + ", file = " + patternmatch); 
	if (patternmatch.matches(regex)) {
	    return true;
	} 

	//	if (patternmatch.indexOf(prefix) == 0) {
	//    return true;
	//} 
	return false;
    }
    private String regex;
}


public class Cperfdmf {
    
    PerfDMFSession perfDMFSession;
    DataSession dataSession;
    
    //int currentApplication = -1;
    //int currentExperiment = -1;
    //int currentTrial = -1;
    
    //Metric currentMetric;


    String exceptionBackTrace;

    final int CPDMF_OK           =  0;
    final int CPDMF_ERR          = -1;
    final int CPDMF_NON_EXISTENT = -2;
    final int CPDMF_ERR_NO_PROFILES  = -3;
    final int CPDMF_ERR_MEMORY = -4;
    final int CPDMF_ERR_BAD_PARSE = -5;
    final int CPDMF_ERR_INTERNAL_ERROR = -6;
    final int CPDMF_ERR_DB_NOT_INITIALIZED = -7;
    final int CPDMF_ERR_SESSION_NOT_INITIALIZED = -8;
    final int CPDMF_ERR_JAVA_EXCEPTION = -9;


    //int currentMetric = -1;

    //    private String encode(String str);
    // Put additional private data here...
    // DO-NOT-DELETE splicer.end(cperfdmf.dmf._data)
    
    public void finalize() {
    
    }

    public int connectDB (
			     /*in*/ java.lang.String configFile,
			     /*in*/ java.lang.String password ) {
	
	perfDMFSession = new PerfDMFSession();
	
	try {

	    if (password == null) {
		perfDMFSession.initialize(configFile,false,false);
	    } else {
		perfDMFSession.initialize(configFile,password,false);
	    }

	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
	
	return CPDMF_OK;
    }

    /**
     * Method:  initializeTauOutput[]
     */
    public int initializeTauOutput (
				    /*in*/ java.lang.String path ) 
    {

	try {
	    
	    Vector v = helperFindFiles(path, "\\Aprofile\\..*\\..*\\..*\\z");
	    
	    if (v.size() == 0) {
		return CPDMF_ERR_NO_PROFILES;
	    }

	    TauOutputSession tauOutputSession = new TauOutputSession();
	  
	    dataSession = tauOutputSession;
	  
	  
	    dataSession.initialize(v);
	  
	  
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  uploadTauOutput[]
     */
    public int uploadTauOutput (
				/*out*/ IntegerHolder newTrialId,
				/*in*/ java.lang.String path,
				/*in*/ int expId ) {
	try {
	    
	    if (perfDMFSession == null) // let's be a bit more helpful than just a null pointer exception
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    //	    Vector v = helperFindFiles(path, "profile.");
	    Vector v = helperFindFiles(path, "\\Aprofile\\..*\\..*\\..*\\z");
	    
	    if (v.size() == 0) {
		return CPDMF_ERR_NO_PROFILES;
	    }
	    
	    TauOutputSession tauOutputSession = new TauOutputSession();
	    
	    DataSession session = tauOutputSession;
	    
	    session.initialize(v);
	  
  
	    // the tau stuff has finished loading, how do we check success?  
	    // no idea, still waiting to hear back on that

	    // get the trial that was just loaded
	    //Trial trial = tauOutputSession.getTrial();
	  
	    Trial trial = new Trial();
	    trial.setDataSession(tauOutputSession);
	    trial.setExperimentID(expId);

	    int newId = perfDMFSession.saveParaProfTrial(trial, -1);

	    trial.setID(newId);
	  
	    newTrialId.set(newId);
	  
	    return CPDMF_OK;
	  
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
     
    }
    
    /**
     * Method:  getApplications[]
     */
    public int getApplications (
				/*out*/ StringHolder applications ) {
	try {
	    String appstr = "";
	    
	    if (perfDMFSession == null) // let's be a bit more helpful than "exception"
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    ListIterator apps = perfDMFSession.getApplicationList();
	    Application app = null;
      
	    while (apps.hasNext()) {
		app = (Application) apps.next();
		appstr = appstr + app.getID() + ';';
	    }

	    applications.set(appstr);
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getApplicationDetail[]
     */
    public int getApplicationDetail (
				     /*out*/ StringHolder detail,
				     /*in*/ int applicationId ) {
	try {
	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.setApplication(applicationId);
	    Application app = perfDMFSession.getApplication();
	    

	    String detailStr = encode(app.getName()) + ";" + 
		app.getID() + ";" + 
		encode(app.getLanguage()) + ";" + 
		encode(app.getParaDiag()) + ";" + 
		encode(app.getUsage()) + ";" + 
		encode(app.getExecutableOptions()) + ";" + 
		encode(app.getDescription()) + ";" + 
		encode(app.getVersion()) + ";"; 
	    
	    detail.set(detailStr);
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  setApplicationDetail[]
     */
    public int setApplicationDetail (
				     /*in*/ String detail,
				     /*out*/ IntegerHolder appId ) {
	try {
	    //System.out.println ("Java: asked to set " + detail);
	    
	    if (perfDMFSession == null) // let's be a bit more helpful than "exception"
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    int pos = 0, end;
	    Application app = new Application();

	    end = getNextStringPosition(detail, pos);
	    app.setName(decode(detail.substring(pos, end))); pos = end+1;
	    //String poo1 = decode(detail.substring(pos, end)); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    app.setID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;
	    //String poo2 = decode(detail.substring(pos, end)); pos = end+1;
    
	    end = getNextStringPosition(detail, pos);
	    app.setLanguage(decode(detail.substring(pos, end))); pos = end+1;
	    //String poo3 = decode(detail.substring(pos, end)); pos = end+1;

	    //System.out.println ("got Name: " + poo1 + "\ngot id: " + poo2 + "\ngot language: " + poo3);

	    end = getNextStringPosition(detail, pos);
	    app.setParaDiag(decode(detail.substring(pos, end))); pos = end+1;


	    end = getNextStringPosition(detail, pos);
	    app.setUsage(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    app.setExecutableOptions(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    app.setDescription(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    app.setVersion(decode(detail.substring(pos, end))); pos = end+1;

	    appId.set(perfDMFSession.saveApplication(app));

	} 

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  deleteApplication[]
     */
    public int deleteApplication (
				  /*in*/ int appId ) {
	try {
	    if (perfDMFSession == null) // let's be a bit more helpful than "exception"
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.deleteApplication(appId);
	}

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  getExperiments[]
     */
    public int getExperiments (
			       /*out*/ StringHolder experiments,
			       /*in*/ int applicationId ) {
	try {
	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.setApplication(applicationId);
	    
	    ListIterator exps = perfDMFSession.getExperimentList();
	    Experiment exp = null;
	    
	    String experimentList = "";
	    
	    while (exps.hasNext()) {
		exp = (Experiment) exps.next();
		experimentList = experimentList + exp.getID() + ';';
	    }

	    experiments.set(experimentList);
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getExperimentDetail[]
     */
    public int getExperimentDetail (
				    /*out*/ StringHolder detail,
				    /*in*/ int experimentId ) {
	try {
	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.setExperiment(experimentId);
	    Experiment exp = perfDMFSession.getExperiment();
      
	    String detailStr = exp.getApplicationID() + ";" + 
		encode(exp.getCompilerCcName()) + ";" +
		encode(exp.getCompilerCcVersion())  + ";" +
		encode(exp.getCompilerCppName()) + ";" +
		encode(exp.getCompilerCppVersion()) + ";" +
		encode(exp.getCompilerJavaDirpath()) + ";" +
		encode(exp.getCompilerJavaVersion()) + ";" +
		encode(exp.getCompilerUserData()) + ";" +
		encode(exp.getConfigArchitecture()) + ";" +
		encode(exp.getConfigCc()) + ";" +
		encode(exp.getConfigCpp()) + ";" +
		encode(exp.getConfigJdk()) + ";" +
		encode(exp.getConfigPrefix()) + ";" +
		encode(exp.getConfigProfile()) + ";" +
		encode(exp.getConfigUserData()) + ";" +
		exp.getID() + ";" + 
		encode(exp.getName()) + ";" +
		encode(exp.getSystemArch()) + ";" +
		encode(exp.getSystemL1CacheSize()) + ";" +
		encode(exp.getSystemL2CacheSize()) + ";" +
		encode(exp.getSystemMachineType()) + ";" +
		encode(exp.getSystemMemorySize()) + ";" +
		encode(exp.getSystemName()) + ";" +
		encode(exp.getSystemOS()) + ";" +
		encode(exp.getSystemProcessorAmount()) + ";" +
		encode(exp.getSystemUserData()) + ";" +
		encode(exp.getUserData()) + ";";

	    detail.set (detailStr);
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  setExperimentDetail[]
     */
    public int setExperimentDetail (
				    /*in*/ java.lang.String detail,
				    /*out*/ IntegerHolder expId ) {
	try {
	    //System.out.println ("Java: asked to set " + detail);
	    
	    int pos = 0, end;
	    Experiment exp = new Experiment();

	    end = getNextStringPosition(detail, pos);
	    exp.setApplicationID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerCcName(decode(detail.substring(pos, end))); pos = end+1;


	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerCcVersion(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerCppName(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerCppVersion(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerJavaDirpath(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerJavaVersion(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setCompilerUserData(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationArchitecture(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationCc(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationCpp(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationJdk(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationPrefix(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationProfile(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setConfigurationUserData(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setName(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemArch(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemL1CacheSize(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemL2CacheSize(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemMachineType(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemMemorySize(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemName(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemOS(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemProcessorAmount(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setSystemUserData(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    exp.setUserData(decode(detail.substring(pos, end))); pos = end+1;

	    expId.set(perfDMFSession.saveExperiment(exp));

	} 

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  deleteExperiment[]
     */
    public int deleteExperiment(
				/*in*/ int expId ) {
	try {
	    if (perfDMFSession == null) // let's be a bit more helpful than "exception"
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.deleteExperiment(expId);
	}

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }
    
    /**
     * Method:  getTrials[]
     */
    public int getTrials(
			 /*out*/ StringHolder trials,
			 /*in*/ int experimentId ) {
	try {
	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
      
	    perfDMFSession.setExperiment(experimentId);
      
	    ListIterator trialIter = perfDMFSession.getTrialList();
	    Trial trial = null;
      
      
	    String trialList = "";
      
	    while (trialIter.hasNext()) {
		trial = (Trial) trialIter.next();
		trialList = trialList + trial.getID() + ';';
	    }
      
	    trials.set(trialList);
	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getTrialDetail[]
     */
    public int getTrialDetail(
			      /*out*/ StringHolder detail,
			      /*in*/ int trialId ) {
	try {
	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.setTrial(trialId);
	    Trial trial = perfDMFSession.getTrial();
	    
	    
	    String detailStr = trial.getApplicationID() + ";" +
		trial.getExperimentID() + ";" +
		trial.getID() + ";" + 
		encode(trial.getName()) + ";" +
		trial.getNodeCount() + ";" +
		trial.getNumContextsPerNode() + ";" +
		trial.getNumThreadsPerContext() + ";" +
		trial.getMetricCount() + ";" +
		encode(trial.getProblemDefinition()) + ";" +
		encode(trial.getTime()) + ";" +
		encode(trial.getUserData()) + ";";
	    detail.set(detailStr);
	    //System.out.println(trial.getName() + " returning " + detailStr);

	    return CPDMF_OK;
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  setTrialDetail[]
     */
    public int setTrialDetail (
			       /*in*/ String detail,
			       /*out*/ IntegerHolder trialId ) {
	try {
	    //System.out.println ("Java: asked to set " + detail);
	    
	    int pos = 0, end;
	    Trial trial = new Trial();
	    
	    end = getNextStringPosition(detail, pos);
	    trial.setApplicationID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;
	 
	    end = getNextStringPosition(detail, pos);
	    trial.setExperimentID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setID(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setName(decode(detail.substring(pos, end))); pos = end+1;


	    end = getNextStringPosition(detail, pos);
	    trial.setNodeCount(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setNumContextsPerNode(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setNumThreadsPerContext(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    //trial.setMetricCount(Integer.parseInt(decode(detail.substring(pos, end)))); pos = end+1;
	    pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setProblemDefinition(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setTime(decode(detail.substring(pos, end))); pos = end+1;

	    end = getNextStringPosition(detail, pos);
	    trial.setUserData(decode(detail.substring(pos, end))); pos = end+1;


	    trialId.set(perfDMFSession.saveTrial(trial));

	} 

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  deleteTrial[]
     */
    public int deleteTrial(
			    /*in*/ int trialId ) {
	try {
	    if (perfDMFSession == null) // let's be a bit more helpful than "exception"
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.deleteTrial(trialId);
	}

	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  selectTrial[]
     */
    public int selectTrial(
			   /*in*/ int trialId ) {
	try {


	    if (perfDMFSession == null)
		return CPDMF_ERR_DB_NOT_INITIALIZED;
	    
	    perfDMFSession.setTrial(trialId);
	    
	    ParaProfDBSession paraProfDBSession = new ParaProfDBSession();
	    
	    dataSession = paraProfDBSession;
	    
	    //dataSession = perfDMFSession;
	    
	    
	    paraProfDBSession.initialize(perfDMFSession);
	    	   
	    return CPDMF_OK;
	 
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  getMetrics[]
     */
    public int getMetrics(
			  /*out*/ StringHolder metrics ) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	  
	    int numMetrics = dataSession.getNumberOfMetrics();

	    String metricList = "";
	  
	    for (int i=0; i<numMetrics; i++) {
		metricList = metricList + encode(dataSession.getMetricName(i)) + ';';
	    }
	    metrics.set(metricList);
	  
	    return CPDMF_OK;
	  
	  
	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
      
    }

    /**
     * Method:  getFunctions[]
     */
    public int getFunctions(
			    /*out*/ StringHolder functions ) {
	// DO-NOT-DELETE splicer.begin(cperfdmf.dmf.getFunctions)
	
	try {

	    
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;

	    
	    GlobalMapping globalMapping = dataSession.getGlobalMapping();
	    if (globalMapping == null) {
		//System.out.println ("session.getGlobalMapping was null!");
		
		// let it do a null pointer exception I guess
	    }
	    
	    Vector list = globalMapping.getMapping(0);
	    

	    String functionList = "";
	    for (Enumeration e = list.elements(); e.hasMoreElements() ;){
		GlobalMappingElement globalMappingElement = (GlobalMappingElement) e.nextElement();
		functionList = functionList + encode(globalMappingElement.getMappingName()) + ";";
	    }
	    functions.set(functionList);
	    return CPDMF_OK;

	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
	
    }

    /**
     * Method:  getNumNodes[]
     */
    public int getNumNodes(
			   /*out*/ IntegerHolder numNodes) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;

	    NCT nct = dataSession.getNCT();
	    numNodes.set(nct.getNumberOfNodes());
	    return CPDMF_OK;
	} 
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getNumContexts[]
     */
    public int getNumContext(/*out*/ IntegerHolder numContexts,
			     /*in*/ int node ) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;

	    NCT nct = dataSession.getNCT();
	    numContexts.set(nct.getNumberOfContexts(node));
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getNumThreads[]
     */
    public int getNumThreads(/*out*/ IntegerHolder numThreads,
			     /*in*/ int node,
			     /*in*/ int context) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;

	    NCT nct = dataSession.getNCT();
	    //	    System.out.println ("
	    numThreads.set(nct.getNumberOfThreads(node, context));
	    return CPDMF_OK;
	} 
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getProfileValues[]
     */
    public int getProfileValues(/*out*/ StringHolder profile,
				/*in*/ int functionId,
				/*in*/ int metric,
				/*in*/ int node,
				/*in*/ int context,
				/*in*/ int thread) {
	try {

	    String profileStr = "";
		
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	    
	    if (node == -1) {
		// get mean
		GlobalMapping gm = dataSession.getGlobalMapping();
		GlobalMappingElement gme = gm.getGlobalMappingElement(functionId,0); // 0 means profiles
		
		profileStr = profileStr + gme.getMeanExclusiveValue(metric) + ";";
		profileStr = profileStr + gme.getMeanInclusiveValue(metric) + ";";
		profileStr = profileStr + gme.getMeanExclusivePercentValue(metric) + ";";
		profileStr = profileStr + gme.getMeanInclusivePercentValue(metric) + ";";
		profileStr = profileStr + gme.getMeanUserSecPerCall(metric) + ";";
		profileStr = profileStr + gme.getMeanNumberOfCalls() + ";";
		profileStr = profileStr + gme.getMeanNumberOfSubRoutines() + ";";


		// throw the groups on using a different delimeter (since this is an array inside of an array)
		int groups[] = gme.getGroups();
		for (int g=0; g<groups.length; g++) {
		    profileStr = profileStr + groups[g] + "@";
		}
		profileStr = profileStr + ";";
		profile.set(profileStr);
		return CPDMF_OK;
	    }

	    if (node == -2) {
		// get total

		GlobalMapping gm = dataSession.getGlobalMapping();
		GlobalMappingElement gme = gm.getGlobalMappingElement(functionId,0); // 0 means profiles


		profileStr = profileStr + gme.getTotalExclusiveValue(metric) + ";";
		profileStr = profileStr + gme.getTotalInclusiveValue(metric) + ";";
		profileStr = profileStr + gme.getTotalExclusivePercentValue(metric) + ";";
		profileStr = profileStr + gme.getTotalInclusivePercentValue(metric) + ";";
		profileStr = profileStr + gme.getTotalUserSecPerCall(metric) + ";";
		profileStr = profileStr + gme.getTotalNumberOfCalls() + ";";
		profileStr = profileStr + gme.getTotalNumberOfSubRoutines() + ";";

		// throw the groups on using a different delimeter (since this is an array inside of an array)
		int groups[] = gme.getGroups();
		for (int g=0; g<groups.length; g++) {
		    profileStr = profileStr + groups[g] + "@";
		}
		profileStr = profileStr + ";";
		profile.set(profileStr);
		return CPDMF_OK;
	    }

	    NCT nct = dataSession.getNCT();
     
	    edu.uoregon.tau.dms.dss.Thread thrd = nct.getThread(node, context, thread);

	    GlobalThreadDataElement gtde = thrd.getFunction(functionId);

	    // null would mean that this N:C:T did not call this function
	    if (gtde == null) {
		profile = null;
		return CPDMF_OK;
	    }


	    profileStr = profileStr + gtde.getExclusiveValue(metric) + ";";
	    profileStr = profileStr + gtde.getInclusiveValue(metric) + ";";
	    profileStr = profileStr + gtde.getExclusivePercentValue(metric) + ";";
	    profileStr = profileStr + gtde.getInclusivePercentValue(metric) + ";";
	    profileStr = profileStr + gtde.getUserSecPerCall(metric) + ";";
	    profileStr = profileStr + gtde.getNumberOfCalls() + ";";
	    profileStr = profileStr + gtde.getNumberOfSubRoutines() + ";";

	    // throw the groups on using a different delimeter (since this is an array inside of an array)
	    int groups[] = gtde.getGroups();
	    for (int g=0; g<groups.length; g++) {
		profileStr = profileStr + groups[g] + "@";
	    }
	    profileStr = profileStr + ";";
	    profile.set(profileStr);
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	// DO-NOT-DELETE splicer.end(cperfdmf.dmf.getProfileValues)
  }

    /**
     * Method:  getUserEvents[]
     */
    public int getUserEvents(/*out*/ StringHolder userEvents,
			     /*in*/ int node,
			     /*in*/ int context,
			     /*in*/ int thread) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	    
	  
	    NCT nct = dataSession.getNCT();
	  
	    edu.uoregon.tau.dms.dss.Thread thrd = nct.getThread(node, context, thread);
	  
	    if (thrd == null) {
		userEvents.set("0;");
		return CPDMF_OK;
	    }

	    ListIterator l;
	  
	    int count = 0;
	  
	    l = thrd.getUsereventListIterator();
	  
	    while (l.hasNext()) {
		GlobalThreadDataElement gtde = (GlobalThreadDataElement) l.next();
		if (gtde!=null) {
		    count++;
		}
	    }

	    //System.out.println ("found " + count + " events");
	  
	    String userEventList = count + ";";
	    l = thrd.getUsereventListIterator();
	  
	    while (l.hasNext()) {
		GlobalThreadDataElement gtde = (GlobalThreadDataElement) l.next();
		if (gtde!=null) {
		    //System.out.println ("getMappingName() = " + gtde.getMappingName());
		    userEventList = userEventList + encode(gtde.getMappingName()) + ";";
		    userEventList = userEventList + gtde.getUserEventNumberValue() + ";";
		    userEventList = userEventList + gtde.getUserEventMinValue() + ";";
		    userEventList = userEventList + gtde.getUserEventMaxValue() + ";";
		    userEventList = userEventList + gtde.getUserEventMeanValue() + ";";
		    userEventList = userEventList + gtde.getUserEventSumSquared() + ";";
		}
	    }
	  
	    userEvents.set(userEventList);
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
	
	// DO-NOT-DELETE splicer.end(cperfdmf.dmf.getUserEvents)
    }
    
    /**
     * Method:  getGroups[]
     */
    public int getGroups(/*out*/ StringHolder groups ) {
	try {

	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	  
	    String functionListStr = new String("");
	  
	    GlobalMapping globalMapping = dataSession.getGlobalMapping();
	    if (globalMapping == null) {
		// let it null pointer exception I guess
	    }
	  
	    Vector list = globalMapping.getMapping(1);  // 1 means 'groups'

	    String groupList = "";
	    for (Enumeration e = list.elements(); e.hasMoreElements() ;){
		GlobalMappingElement globalMappingElement = (GlobalMappingElement) e.nextElement();

		//		if (globalMappingElement.getMappingName() == "") {
		    groupList = groupList + encode(globalMappingElement.getMappingName()) + ";";
		    
		    //}

	    }

	    
	    //System.out.println ("groupList = " + groupList);

	    groups.set(groupList);

	} catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}

	return CPDMF_OK;
    }

    /**
     * Method:  queryNodeExists[]
     */
    public int queryNodeExists(/*out*/ IntegerHolder exists,
			       /*in*/ int node ) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	    
	    NCT nct = dataSession.getNCT();
	    
	    edu.uoregon.tau.dms.dss.Node nde = nct.getNode(node);
	    
	    if (nde != null) {
		exists.set(1);
	    } else {
		exists.set(0);
	    }
	    
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  queryContextExists[]
     */
    public int queryContextExists(/*out*/ IntegerHolder exists,
				  /*in*/ int node,
				  /*in*/ int context) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	    
	    NCT nct = dataSession.getNCT();
	    
	    edu.uoregon.tau.dms.dss.Context cntxt = nct.getContext(node, context);
	    
	    if (cntxt != null) {
		exists.set(1);
	    } else {
		exists.set(0);
	    }
	    
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }
    
    /**
     * Method:  queryThreadExists[]
     */
    public int queryThreadExists(/*out*/ IntegerHolder exists,
				 /*in*/ int node,
				 /*in*/ int context,
				 /*in*/ int thread) {
	try {
	    if (dataSession == null)
		return CPDMF_ERR_SESSION_NOT_INITIALIZED;
	    
	    NCT nct = dataSession.getNCT();
	    
	    edu.uoregon.tau.dms.dss.Thread thrd = nct.getThread(node, context, thread);
	    
	    if (thrd != null) {
		exists.set(1);
	    } else {
		exists.set(0);
	    }
	    
	    return CPDMF_OK;
	}
	catch (Exception e) {
	    setBackTraceMessage(e);
	    return CPDMF_ERR_JAVA_EXCEPTION;
	}
    }

    /**
     * Method:  getExceptionMessage[]
     */

    public java.lang.String getExceptionMessage () {
	return exceptionBackTrace;
    }
    
    
    

    private Vector helperFindFiles (String path, String prefix) {
	Vector v = new Vector();
	
	File file = new File(path);
	if (file.isDirectory() == false) {
	    return v;
	}
	FilenameFilter prefixFilter = new FileFilter(prefix);
	File files[] = file.listFiles(prefixFilter);
	
	if (files.length == 0) {
	    // we didn't find any profile files here, now look for MULTI_ directories
	    FilenameFilter multiFilter = new FileFilter("MULTI__.*");
	    File multiDirs[] = file.listFiles(multiFilter);
	    
	    for (int i=0; i<multiDirs.length; i++) {
		File finalFiles[] = multiDirs[i].listFiles(prefixFilter);
		v.add(finalFiles);
	    }
	} else {
	    v.add(files);
	    return v;
	}
	return v;
    }

    private void setBackTraceMessage(Exception e) {
	StringWriter sw = new StringWriter();
	PrintWriter pw = new PrintWriter(sw);
	e.printStackTrace(pw);
	pw.close();
	this.exceptionBackTrace = sw.toString();
	//e.printStackTrace();
    }



    private int getNextStringPosition(String str, int pos) {
	boolean done = false;
	while (pos < str.length()) {
	    if (str.charAt(pos) == ';')
		return pos;

	    if (str.charAt(pos) == '\\')
		pos++;

	    pos++;
	}
	return pos;
    }

    private String encode(String str) {
	if (str == null) return "";
	str = str.replaceAll("\\\\", "\\\\\\\\");
	str = str.replaceAll(";","\\\\;");
	return str;
    }

    private String decode(String str) {
	if (str == null) return "";
	str = str.replaceAll("\\\\;",";");
	str = str.replaceAll("\\\\\\\\","\\\\");
	return str;
    }

}
